<template>
    <v-card app style="border: 2px solid #424242;" >

        <div style="height: 80px;">

        </div>
      
        <div style="position: absolute; left: 20px; top: 10px; cursor: pointer;"  >
          <div style="display: flex; align-items: center;">
          <img class="logo" src="/assets/img/green-spade.png" height="60" />

          &nbsp;
          &nbsp;
          <span class="appname"> Template</span>
          <!-- <img src="/assets/img/apsim.png" height=""/> -->
            </div>
        </div>


  
      
      <div style=" height: 60px; position: absolute; right: 15px; bottom: 15px; display: flex;">



        <v-list-item class="noHover" 
        lines="two"
        prepend-avatar="/assets/img/user.png"
        :title="authUser.username"
        subtitle="Demo Mode"
        link>
      
        <v-menu
         activator="parent"
          bg-color="dark"
          transition="slide-y-transition"
          origin="top left"
          >
        
          <v-list-item  style="background-color: #424242;">
            <v-btn variant="plain" @click="logout"> Log Out</v-btn>
          </v-list-item>
        
        </v-menu>
      
      </v-list-item>
        <v-list-item>

        <v-icon v-if="currentTheme == 'light'" @click="cycleTheme" >mdi-brightness-5</v-icon>
        <v-icon v-if="currentTheme == 'dark'" @click="cycleTheme">mdi-brightness-2</v-icon>
        <v-icon v-if="currentTheme == 'system'" @click="cycleTheme">mdi-brightness-auto</v-icon>

        </v-list-item>
        
      </div>
      
      <!-- <v-tabs
        v-model="tab"
        bg-color="dark"
        density="comfortable"
        align-tabs="center"
      > -->
      <!-- <div style="width: 120px;"></div> -->
      <!-- <v-tab v-for="item in items" :key="item.title" :prepend-icon="item.icon" :title="item.title" :to="item.route" link></v-tab>
      <v-tab v-if="hasAdminPermissions" prepend-icon="mdi-account-group" title="Admin" to="/admin/settings" link></v-tab>
     
      
    </v-tabs> -->

    
  </v-card>
  <!-- <BreadCrumbs /> -->
</template>
<style>
.version{
  font-size: small;
  color: #777;
}

.noHover:hover {
  background-color: inherit !important;
}

.logo {
    /* Round border grey */
    border: 2px solid #3fb649;
    border-radius: 5%;
    padding: 5px;
}

.appname{
  color: #3fb649;
  font: 3em Broadway;
}

</style>
<script>

import { ref , onMounted, computed} from 'vue'
import { VCard } from 'vuetify/lib/components'
import BreadCrumbs from './BreadCrumbs.vue'
import versionData from '../version.json'
import { useTheme } from 'vuetify'
import { useAuthStore } from '@/store/auth'
import router from '@/router'




export default {
    props: {
        navItems: {
            type: Array,
            default: () => []
        }
    },
    setup(props) {
        const authStore = useAuthStore();
        const tab = ref(null);
        const items = ref(props.navItems);
        const dashVersion = ref(versionData.version_string);
        const themeIdx = ref(0);
        const theme = useTheme();
        const themes = [
            'system',
            'light',
            'dark'
        ];


        const authUser  = computed(() => {
            return authStore.authUser;
        });

        const hasAdminPermissions = computed(() => {
          return authUser.value.permissions.includes('admin:read');
        });

        const currentTheme = computed(() => {return themes[themeIdx.value];});


        function cycleTheme() {
          themeIdx.value = (themeIdx.value + 1) % themes.length;

          let themeName = themes[themeIdx.value];

          if(themeName === 'system') {

            if(window.matchMedia && window.matchMedia('(prefers-color-scheme: dark)').matches) {
              themeName = 'ApSimDark'
            }
            else
            {

              themeName = 'ApSimLight'
            }

          }

          if(themeName === 'light') {
            themeName = 'ApSimLight'
          }
          else if(themeName === 'dark') {
            themeName = 'ApSimDark'
          }

          theme.global.name.value = themeName;

        }


        function logout() {
          authStore.logout();
          router.push('/login')
        }



        return {
            tab,
            items,
            currentTheme,
            cycleTheme,
            authUser,
            logout,
            hasAdminPermissions,
        };
    },
    components: { VCard, BreadCrumbs }
}

</script>
<style>
.fixxedRight {
  position: relative !important;
  right: 60px !important;
}
</style>